/*-
 * This file is a part of the MDCacheD server
 * (c) 2012. Ivan Voras <ivoras@gmail.com>
 * Released under the 2-clause BSDL
 * $Id: SizeHistogram.h 429 2012-03-01 01:20:50Z ivoras $
 */

#include "misc.h"
#include "SizeHistogram.h"

#define MODEL_SIZE_HISTOGRAM_CUTOFF 8192

/**
 * The ServerModelMetadata class holds the metadata maintained by the exact
 * caller of the ServerClientConnection::process_command(), which varies per
 * the multithreading model. Its main purpose is to allow keeping unsynchronized
 * statistics information.
 */
class ServerModelMetadata {
private:
public:
	SizeHistogram<MODEL_SIZE_HISTOGRAM_CUTOFF> size_hist;
};

