/*
 * MDCacheD benchmark utilities
 * (c) 2008.-2011. Ivan Voras <ivoras@gmail.com>
 * $Id: bench_utils.c 380 2011-11-10 00:19:34Z ivoras $
 */

#include <sys/time.h>

#include "linux-shims.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <assert.h>

#include "bench_utils.h"
#include "hash.h"


/* Creates a key-value pair from the given index # */
void gen_data(unsigned int n, char **key, unsigned int *key_len, char **data, unsigned int *data_len, float scale)
{
	*key_len = asprintf(key, "k%u-:-%x", n, hash32_buf(&n, sizeof n));
	*data_len = (unsigned int)(logf(n+3)*10*scale);
	*data = malloc(*data_len);
	memset(*data, n == 0 ? 1 : n & 0xff, *data_len);
	(*data)[*data_len-1] = '\0';
	assert(*data_len >= 0 && *data_len <= 65536);
}

